=== debian/changelog ===
libavif (0.10.1-2build1) kinetic; urgency=medium

  * No-change rebuild against libsvtav1enc1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 23 Aug 2022 01:15:52 +0000

libavif (0.10.1-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Remove unused license definitions for Expat.

  [ Boyuan Yang ]
  * Rebuild against libgav1 (>> 0.18).
  * debian/rules: Pass -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON via
    dh_auto_configure override. (Closes: #1003371)

 -- Boyuan Yang <byang@debian.org>  Thu, 28 Jul 2022 14:31:47 -0400

libavif (0.10.1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Mon, 02 May 2022 13:00:03 -0400

libavif (0.10.1-1~exp1) experimental; urgency=medium

  * New upstream version 0.10.1.

 -- Boyuan Yang <byang@debian.org>  Sat, 16 Apr 2022 20:56:42 -0400

libavif (0.10.0-1~exp1) experimental; urgency=medium

  * New upstream version 0.10.0.
  * debian/: Enable svt-av1 encoder flags on supported platforms.
  * Bump library SONAME to 14.
  * debian/copyright: Refresh license information.
  * debian/patches: Dropped, not used anymore.

 -- Boyuan Yang <byang@debian.org>  Mon, 11 Apr 2022 13:32:43 -0400
