=== debian/changelog ===
libavif (0.11.1-3ubuntu1) mantic; urgency=medium

  * Merge from debian unstable. Remaining changes:
    - Don't build manpages on i386, we don't have pandoc.
    - Also do not build with RAV1E on i386, as this is not
      available in Ubuntu.

 -- Rik Mills <rikmills@kde.org>  Thu, 13 Jul 2023 21:12:57 +0100

libavif (0.11.1-3) unstable; urgency=medium

  * debian/rules: Do not install man pages if they are not built.

 -- Boyuan Yang <byang@debian.org>  Thu, 13 Jul 2023 09:54:12 -0400

libavif (0.11.1-2) unstable; urgency=medium

  * d/control,d/rules: Disable pandoc support on architectures
    with broken pandoc: kfreebsd-*, m68k, powerpc, sh4, x32.
  * debian/control: Bump Standards-Version to 4.6.2.
  * debian/control: Migrate from old build-dep:
    libgdk-pixbuf2.0-dev => libgdk-pixbuf-2.0-dev. (Closes: #1037383)

 -- Boyuan Yang <byang@debian.org>  Thu, 13 Jul 2023 08:37:58 -0400

libavif (0.11.1-1ubuntu2) lunar; urgency=medium

  * debian/control: Also do not build with librav1e-dev on i386.
  * debian/rules:
    - Remove i386 from architectures RAV1E build option is enabled on.
    - As manpages are now not built on i386, skip their installation
      on i386 via execute_after_dh_install.

 -- Rik Mills <rikmills@kde.org>  Tue, 29 Nov 2022 09:48:46 +0000

libavif (0.11.1-1ubuntu1) lunar; urgency=medium

  * Don't build manpages on i386, we don't have pandoc.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 28 Nov 2022 02:41:27 +0000

libavif (0.11.1-1) unstable; urgency=medium

  * New upstream version 0.11.1.

 -- Boyuan Yang <byang@debian.org>  Tue, 25 Oct 2022 11:39:25 -0400

libavif (0.11.0-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Wed, 19 Oct 2022 17:14:35 -0400

libavif (0.11.0-1~exp1) experimental; urgency=medium

  * New upstream version 0.11.0.
    + Bump library SONAME to 15.
  * debian/watch: Properly handle -rc tag.
  * debian/control: Enable building man pages.
  * debian/copyright: Refreshed.

 -- Boyuan Yang <byang@debian.org>  Tue, 18 Oct 2022 15:52:57 -0400

libavif (0.10.1-3) unstable; urgency=medium

  * debian/: Enable rav1e support. (Closes: #972466)
  * debian/control: Bump Standards-Version to 4.6.1.

 -- Boyuan Yang <byang@debian.org>  Tue, 18 Oct 2022 14:58:51 -0400
