=== debian/control ===
--- 
+++ 
@@ -6,22 +6,26 @@
 Uploaders:
  Boyuan Yang <byang@debian.org>,
 Build-Depends:
- cmake,
+ cmake (>= 3.13),
  debhelper-compat (= 13),
  libaom-dev (>= 3~),
  libcjson-dev,
  libdav1d-dev,
 # only enable when libgav1-dev exist, see rules file
  libgav1-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x hppa ppc64 riscv64 x32],
- libgdk-pixbuf2.0-dev,
+ libgdk-pixbuf-2.0-dev,
  libjpeg-dev,
  libpng-dev,
+# only enable when librav1e-dev exist, see rules file
+ librav1e-dev [amd64 arm64 armel armhf mips64el mipsel ppc64el s390x powerpc ppc64],
 # only enable when libsvtav1enc-dev exist, see rules file
  libsvtav1enc-dev [amd64 arm64 armel armhf mips64el mipsel ppc64el s390x hppa ia64 m68k powerpc ppc64 riscv64 sh4 sparc64],
  libyuv-dev,
+# Disable doc build on arch with broken pandoc: kfreebsd-*, m68k, powerpc, sh4, x32
+ pandoc [!i386 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !sh4 !x32] <!nodoc>,
  pkg-config,
  zlib1g-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/AOMediaCodec/libavif
 Vcs-Git: https://salsa.debian.org/multimedia-team/libavif.git
@@ -31,7 +35,7 @@
 Section: utils
 Architecture: any
 Depends:
- libavif14 (= ${binary:Version}),
+ libavif15 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Description: Library for handling .avif files (utilities)
@@ -41,16 +45,13 @@
  This package provides several utilities provided by the library:
   - avifdec
   - avifenc
- .
- Due to the temporary lack of support libraries, no decoder is available
- for now. As a result, the avifenc binary won't work.
 
 Package: libavif-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
 Depends:
- libavif14 (= ${binary:Version}),
+ libavif15 (= ${binary:Version}),
  ${misc:Depends},
 Description: Library for handling .avif files (development files)
  This library aims to be a friendly, portable C implementation of the AV1
@@ -58,7 +59,7 @@
  .
  This package provides the development files.
 
-Package: libavif14
+Package: libavif15
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -74,7 +75,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libavif14 (= ${binary:Version}),
+ libavif15 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Breaks:
